"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = __importStar(require("lodash"));
const helpers_1 = require("./helpers");
const index_1 = require("./index");
function currentDirectoryInstall(options) {
    return readLocalDependencies(options.dependencies)
        .then(localDependencies => {
        const installer = new index_1.LocalInstaller({ '.': localDependencies });
        index_1.progress(installer);
        return installer.install()
            .then(index_1.saveIfNeeded(options));
    });
}
exports.currentDirectoryInstall = currentDirectoryInstall;
function readLocalDependencies(dependenciesFromArguments) {
    if (dependenciesFromArguments.length) {
        return Promise.resolve(dependenciesFromArguments);
    }
    else {
        return helpers_1.readPackageJson('.').then((pkg) => {
            return _.values(pkg.localDependencies);
        });
    }
}
//# sourceMappingURL=currentDirectoryInstall.js.map